﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace trtris
{
    class Brick
    {
        public PictureBox Frist { get; private set; }
        public PictureBox OnePicture { get; private set; }
        public PictureBox TwoPicture { get; private set; }
        public PictureBox ThreePicture { get; private set; }
        public BrickType BT { get; private set; }
        private int VariantNumber = -1;
        /// <summary>
        /// 创建一个PictureBox类型变量
        /// </summary>
        /// <param name="BT">PictureBox类型</param>
        /// <returns></returns>
        private PictureBox NewPricture(BrickType BT)
        {
            PictureBox Result = new PictureBox();
            Result.Size = new Size(20, 20);
            Result.Image = BT.BackgroundImg;
            Result.SizeMode = PictureBoxSizeMode.CenterImage;
            return Result;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public PictureBox[] ToArray()
        {
            return new PictureBox[] { Frist, OnePicture, TwoPicture, ThreePicture };
        }
        /// <summary>
        /// 改变形状
        /// </summary>
        /// <param name="BT"></param>
        public void NextVariant(BrickType BT)
        {
            if (++VariantNumber < BT.Variants.Count)
            {
                BT.Variants[VariantNumber](this);
            }
            else
            {
                VariantNumber = 0;
                BT.Variants[VariantNumber](this);
            }
        }
        /// <summary>
        /// 默认形状
        /// </summary>
        public void MorenVariant()
        {
            this.BT.Variants[0](this);
        }
        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="BT">BrickType方块类型</param>
        /// <param name="Pint">Brick方块出现的位置</param>
        public Brick(Point Pint)
        {
            BT = new BrickType();
            Frist = NewPricture(BT);
            OnePicture = NewPricture(BT);
            TwoPicture = NewPricture(BT);
            ThreePicture = NewPricture(BT);
            Frist.Location = Pint;
            NextVariant(BT);
        }
    }
}
