﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace trtris
{
    delegate void Variant(Brick vrick);
    class BrickType
    {
        public int BrickTypeNum { get; private set; }
        public Image BackgroundImg { get; private set; }
        public List<Variant> Variants = new List<Variant>();
        /// <summary>
        /// 第一种四个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant1_1(Brick vrick)
        {
            Variant(vrick, -20, 0, 20, 0, 20, 20);
        }
        public void Variant1_2(Brick vrick)
        {
            Variant(vrick, 0, 20, -20, 20, 0, -20);
        }
        public void Variant1_3(Brick vrick)
        {
            Variant(vrick, -20, 0, 20, 0, -20, -20);
        }
        public void Variant1_4(Brick vrick)
        {
            Variant(vrick, 0, 20, 0, -20, 20, -20);
        }
        /// <summary>
        /// 第二种 四个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant2_1(Brick vrick)
        {
            Variant(vrick, -20, 0, 20, 0, 20, -20);
        }
        public void Variant2_2(Brick vrick)
        {
            Variant(vrick, 0, 20, 0, -20, 20, 20);
        }
        public void Variant2_3(Brick vrick)
        {
            Variant(vrick, -20, 0, 20, 0, -20, 20);
        }
        public void Variant2_4(Brick vrick)
        {
            Variant(vrick, 0, 20, 0, -20, -20, -20);
        }
        /// <summary>
        /// 第三种  两个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant3_1(Brick vrick)
        {
            Variant(vrick, -20, 0, 0, -20, 20, -20);
        }
        public void Variant3_2(Brick vrick)
        {
            Variant(vrick, -20, 0, 0, 20, -20, -20);
        }
        /// <summary>
        /// 第四种  两个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant4_1(Brick vrick)
        {
            Variant(vrick, 0, -20, 20, 0, -20, -20);
        }
        public void Variant4_2(Brick vrick)
        {
            Variant(vrick, 20, 0, 20, -20, 0, 20);
        }
        /// <summary>
        /// 第五种  四个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant5_1(Brick vrick)
        {
            Variant(vrick, 20, 0, -20, 0, 0, -20);
        }
        public void Variant5_2(Brick vrick)
        {
            Variant(vrick, 0, -20, 0, 20, 20, 0);
        }
        public void Variant5_3(Brick vrick)
        {
            Variant(vrick, 20, 0, -20, 0, 0, 20);
        }
        public void Variant5_4(Brick vrick)
        {
            Variant(vrick, 0, -20, 0, 20, -20, 0);
        }
        /// <summary>
        /// 第六种  两个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant6_1(Brick vrick)
        {
            Variant(vrick, 0, 20, 0, -20, 0, -40);
        }
        public void Variant6_2(Brick vrick)
        {
            Variant(vrick, -40, 0, -20, 0, 20, 0);
        }
        /// <summary>
        /// 第七种  一个状态
        /// </summary>
        /// <param name="vrick"></param>
        public void Variant7_1(Brick vrick)
        {
            Variant(vrick, 0, -20, -20, 0, -20, -20);
        }
        /// <summary>
        /// 改变另外三个子方框相对Frist定位框的位置
        /// </summary>
        /// <param name="vrick"></param>
        /// <param name="OneX"></param>
        /// <param name="OneY"></param>
        /// <param name="TowX"></param>
        /// <param name="TowY"></param>
        /// <param name="ThreeX"></param>
        /// <param name="ThreeY"></param>
        private void Variant(Brick vrick, int OneX, int OneY, int TowX, int TowY, int ThreeX, int ThreeY)
        {
            if (TetrisUI.HuanWeiZhi(new Point[] { 
                new Point(vrick.Frist.Location.X + OneX, vrick.Frist.Location.Y + OneY),
                new Point(vrick.Frist.Location.X + TowX, vrick.Frist.Location.Y + TowY),
                new Point(vrick.Frist.Location.X + ThreeX, vrick.Frist.Location.Y + ThreeY)
            }))
            {
                vrick.OnePicture.Location = new Point(vrick.Frist.Location.X + OneX, vrick.Frist.Location.Y + OneY);
                vrick.TwoPicture.Location = new Point(vrick.Frist.Location.X + TowX, vrick.Frist.Location.Y + TowY);
                vrick.ThreePicture.Location = new Point(vrick.Frist.Location.X + ThreeX, vrick.Frist.Location.Y + ThreeY);
            }
        }
        public BrickType()
        {
            Random Rd = new Random();
            BrickTypeNum = Rd.Next(0, 7);
            switch (BrickTypeNum)
            {
                case 0:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\橙.png");
                    Variants.Add(Variant1_1);
                    Variants.Add(Variant1_2);
                    Variants.Add(Variant1_3);
                    Variants.Add(Variant1_4);
                    break;
                case 1:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\粉.png");
                    Variants.Add(Variant2_1);
                    Variants.Add(Variant2_2);
                    Variants.Add(Variant2_3);
                    Variants.Add(Variant2_4);
                    break;
                case 2:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\蓝.png");
                    Variants.Add(Variant3_1);
                    Variants.Add(Variant3_2);
                    break;
                case 3:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\绿.png");
                    Variants.Add(Variant4_1);
                    Variants.Add(Variant4_2);
                    break;
                case 4:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\青.png");
                    Variants.Add(Variant5_1);
                    Variants.Add(Variant5_2);
                    Variants.Add(Variant5_3);
                    Variants.Add(Variant5_4);
                    break;
                case 5:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\紫.png");
                    Variants.Add(Variant6_1);
                    Variants.Add(Variant6_2);
                    break;
                case 6:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\黄.png");
                    Variants.Add(Variant7_1);
                    break;
                case 7:
                    BackgroundImg = Image.FromFile(@"..\..\Resources\红.png");
                    break;
                default:
                    throw new Exception("超出界限");
            }
        }
    }
}
