﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace trtris
{
    public partial class TetrisUI : Form
    {
        public TetrisUI()
        {
            InitializeComponent();
        }
        // 游戏横向方块个数
        const int GameWidth = 20;
        // 游戏纵向方块个数
        const int GameHeight = 25;
        // 方块大小 暂不支持改动
        const int NodeSize = 20;
        // 当前行动元素
        private Brick brick;
        // 下一个元素
        private Brick NextBrick;
        // 所有方块集合
        static List<PictureBox> AllPic = new List<PictureBox>();
        // 游戏区域容器
        Panel pl;
        // 定时器
        Timer setInterval;
        //游戏结束
        bool Gameover = false;
        //游戏积分
        int integral = 0;
        //按键次数
        int step = 0;
        //隐身超变态级别是否开启
        bool AllpicHide = false;
        //开始时间
        DateTime LoadTime = DateTime.Now;
        /// <summary>
        /// Game初始化参数
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TetrisUI_Load(object sender, EventArgs e)
        {
            ///游戏加载创建游戏区域
            pl = new Panel();
            pl.Size = new Size(GameWidth * NodeSize, GameHeight * NodeSize);
            pl.Location = new Point(0, 0);
            pl.BorderStyle = BorderStyle.FixedSingle;

            //设置背景图片  会导致重绘残影
            //pl.BackgroundImage = Image.FromFile(@"..\..\Resources\img_1304385785_176.jpg");
            //pl.BackgroundImageLayout = ImageLayout.Center;
         
            this.Controls.Add(pl);
            ///根据创建的游戏区域设置窗口大小
            this.ClientSize = new Size(GameWidth * NodeSize + plRight.Width, GameHeight * NodeSize);
            plRight.Size = new Size(plRight.Width, GameHeight * NodeSize);
            plRight.Location = new Point(GameWidth * NodeSize, 0);

            ///初始化当前下落的元素
            brick = new Brick(new Point(pl.Size.Width / NodeSize / 2 * NodeSize, -NodeSize * 2));
            Random Rd = new Random();
            ///由于同时创建两个元素会导致重复  使游戏进程暂停0-5毫秒
            System.Threading.Thread.Sleep(Rd.Next(0, 6));

            plRightMan.Size = new Size(plRightMan.Width, GameHeight * NodeSize - 150);
            pl.Controls.AddRange(brick.ToArray());
            NextBrick = new Brick(new Point(plRight.Size.Width / NodeSize / 2 * NodeSize, 50));
            plRight.Controls.AddRange(NextBrick.ToArray());

            ///设置游戏定时器
            setInterval = new Timer();
            setInterval.Interval = 300;
            setInterval.Enabled = true;
            setInterval.Tick += Interval_Tick;

            //开始按钮
            setInterval.Enabled = false;
            Button btnStart = new Button();
            btnStart.Text = "开始";
            btnStart.Size = new Size(80, 30);
            btnStart.Location = new Point((pl.Size.Width - btnStart.Size.Width) / 2, (pl.Size.Height - btnStart.Size.Height) / 2);
            btnStart.Click += Start_Click;
            pl.Controls.Add(btnStart);
            pl.PreviewKeyDown += pl_PreviewKeyDown;

            //右侧参数
            lbIntegral.Text = integral.ToString();
            lbStep.Text = step.ToString();
            lbTime.Text = (DateTime.Now.Subtract(LoadTime)).ToString().Substring(0,8);
            
        }



        /// <summary>
        /// 判断下一步操作是否可以执行
        /// </summary>
        /// <param name="points">下一步操作方块要到达位置的集合</param>
        /// <returns>返回true可以执行  返回false则不可以</returns>
        public static bool HuanWeiZhi(Point[] points)
        {
            foreach (Point p in points)
            {
                if (p.X < 0 || p.X > GameWidth * NodeSize - NodeSize || p.Y > GameHeight * NodeSize - NodeSize)
                {
                    return false;
                }
                string TempName = (GameHeight - p.Y / NodeSize).ToString() + "," + (p.X / NodeSize + 1).ToString();
                foreach (PictureBox pic in AllPic)
                {
                    if (pic.Name == TempName)
                    {
                        return false;
                    }
                }
            }
            return true;
        }
        /// <summary>
        /// 按键操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pl_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            if (e.KeyValue > 36 && e.KeyValue < 41 && setInterval.Enabled && !Gameover)
            {
                setInterval.Enabled = false;
                if (e.KeyValue == 38)
                {
                    brick.NextVariant(brick.BT);
                }
                if (e.KeyValue == 37)
                {
                    List<Point> Temp = new List<Point>();
                    foreach (PictureBox P in brick.ToArray())
                    {
                        Temp.Add(new Point(P.Location.X - NodeSize, P.Location.Y));
                    }
                    if (HuanWeiZhi(Temp.ToArray()))
                    {
                        foreach (PictureBox P in brick.ToArray())
                        {
                            P.Location = new Point(P.Location.X - NodeSize, P.Location.Y);
                        }
                    }
                }
                if (e.KeyValue == 39)
                {
                    List<Point> Temp = new List<Point>();
                    foreach (PictureBox P in brick.ToArray())
                    {
                        Temp.Add(new Point(P.Location.X + NodeSize, P.Location.Y));
                    }
                    if (HuanWeiZhi(Temp.ToArray()))
                    {
                        foreach (PictureBox P in brick.ToArray())
                        {
                            P.Location = new Point(P.Location.X + NodeSize, P.Location.Y);
                        }
                    }
                }
                if (e.KeyValue == 40)
                {
                    while (!Gameover && DownClick()) { }
                }

                setInterval.Enabled = true;
                step++;
                lbStep.Text = step.ToString();
            }
        }
        /// <summary>
        /// Timer的Tick事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Interval_Tick(object sender, EventArgs e)
        {
            lbTime.Text = (DateTime.Now.Subtract(LoadTime)).ToString().Substring(0, 8);
            DownClick();
        }

        /// <summary>
        /// 开始按钮事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Start_Click(object sender, EventArgs e)
        {
            setInterval.Enabled = true;
            LoadTime = DateTime.Now;
            //移除按钮  否则KeyDown事件不能触发
            pl.Controls.Remove((Button)sender);
        }

        /// <summary>
        /// 每次循环执行的方法
        /// </summary>
        /// <returns></returns>
        private bool DownClick()
        {
            if (!XiaLuo(brick.ToArray()) && !Gameover)
            {
                brick = NextBrick;
                brick.Frist.Location = new Point(GameWidth / 2 * NodeSize, -NodeSize * 2);
                pl.Controls.AddRange(brick.ToArray());
                brick.MorenVariant();
                NextBrick = new Brick(new Point(plRight.Size.Width / NodeSize / 2 * NodeSize, 50));
                plRight.Controls.AddRange(NextBrick.ToArray());
                return false;
            }
            return true;
        }

        /// <summary>
        /// 指定元素集合集体下落
        /// </summary>
        /// <param name="PicList"></param>
        /// <returns></returns>
        private bool XiaLuo(PictureBox[] PicList)
        {
            bool Result = true;
            List<Point> Temp = new List<Point>();
            foreach (PictureBox P in PicList)
            {
                Temp.Add(new Point(P.Location.X, P.Location.Y + NodeSize));
            }
            if (HuanWeiZhi(Temp.ToArray()))
            {
                foreach (PictureBox P in PicList)
                {
                    P.Location = new Point(P.Location.X, P.Location.Y + NodeSize);
                }
            }
            else
            {
                foreach (PictureBox p in PicList)
                {
                    int X = p.Location.X / NodeSize + 1;
                    int Y = GameHeight - p.Location.Y / NodeSize;
                    if (Y > GameHeight)
                    {
                        GameOver();
                        return false;
                    }
                    p.Name = Y.ToString() + "," + X.ToString();
                    AllPic.Add(p);
                }
                //如果开启隐身模式  隐藏静止元素
                if (AllpicHide)
                {
                    System.Threading.Thread.Sleep(300);
                    foreach (PictureBox p in PicList)
                    {
                        p.Visible = false;
                    }
                }
                for (int i = 1; i <= GameHeight; i++)
                {
                    bool kaiguan = true;
                    List<PictureBox> TempRow = new List<PictureBox>();
                    int j = 1;
                    while (kaiguan)
                    {
                        PictureBox p = SelectPicByName(i + "," + j);
                        if (p != null)
                        {
                            TempRow.Add(p);
                            j++;
                        }
                        else
                        {
                            kaiguan = false;
                        }
                    }
                    if (TempRow.Count >= GameWidth)
                    {
                        for (int ii = 0; ii < TempRow.Count; ii++)
                        {
                            pl.Controls.Remove(TempRow[ii]);
                            AllPic.Remove(TempRow[ii]);
                            TempRow[ii].Dispose();
                        }
                        integral += GameWidth;
                        lbIntegral.Text = integral.ToString();
                        updateGameRank(integral);
                        List<PictureBox> PictureBoxList = new List<PictureBox>();
                        foreach (PictureBox p in AllPic)
                        {
                            if (Convert.ToInt32(p.Name.Split(',')[0]) > i)
                            {
                                p.Name += "p";
                                PictureBoxList.Add(p);
                            }
                        }
                        ///将将要移动位置的元素在所有元素集合中移除
                        foreach (PictureBox p in PictureBoxList)
                        {
                            AllPic.Remove(p);
                        }
                        bool derail = XiaLuo(PictureBoxList.ToArray());
                        while (derail)
                        {
                            derail = XiaLuo(PictureBoxList.ToArray());
                        }
                    }
                }
                Result = false;
            }
            return Result;
        }

        /// <summary>
        /// 根据Name属性查找PictureBox控件  查询到返回查询到的控件  否则返回空控件
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        private PictureBox SelectPicByName(string name)
        {
            foreach (PictureBox p in AllPic)
            {
                if (p.Name == name)
                    return p;
            }
            return null;
        }
        /// <summary>
        /// 等级设置 暂时就静态放在这儿吧 
        /// </summary>
        /// <param name="integral"></param>
        private void updateGameRank(int integral)
        {
            if (integral >= 80)
            {
                lbGameRank.Text = "隐身级别";
                AllpicHide = true;
                setInterval.Interval = 200;
            }
            else if (integral >= 60)
            {
                lbGameRank.Text = "变态级别";
                setInterval.Interval = 100;
            }
            else if (integral >= 40)
            {
                lbGameRank.Text = "疯狂级别";
                setInterval.Interval = 200;
            }
            else if (integral >= 20)
            {
                lbGameRank.Text = "困难级别";
                setInterval.Interval = 250;
            }
        }
        private void GameOver()
        {
            setInterval.Enabled = false;
            Gameover = true;
            if (AllpicHide)
            {
                foreach (PictureBox p in AllPic)
                {
                    p.Visible = true;
                }
            }
            MessageBox.Show("GameOver");
        }
    }
}
